'*******************************************************************************
'Programm for Display ILI9486 320x480 Pixel
'
'Bascom IDE 2.0 8.1
'
'    Version: V10
'    Date:22.05.2014
'    Email: Hkipnik@aol.com
'    Copyright (c) 2013 Hkipnik.  All rights reserved.
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'*******************************************************************************
$nocompile


'*******************************************************************************
' Draw Box x start -- y start -- xend -- yend -- 1=fill 2=fill with Border 3=no fill -- color -- bordercolor
'*******************************************************************************
Sub Lcd_box(byval Xstart As Word , Byval Ystart As Word , Byval Xend As Word , Byval Yend As Word , Byval Fill As Byte , Byval Color As Word , Byval Bordercolor As Word)

   Hoehe = Yend - Ystart
   Breit = Xend - Xstart
   Decr Xend
   If Fill = 1 Then
      Lcd_set_window Xstart , Ystart , Xend , Yend


      Lcd_cs = 0
      Lcd_dc = 1

      !ldd R26, Y+2
      !Ldd R27, Y+3
      !LD R10, X+
      !LD R11, X
      !LDS     R24,       {Hoehe}                           'Anzahl lines
      !LDS     R25,       {Hoehe+1}
      Lo_rows:
         !LDS     R30,       {Breit}                        'Anzahl Pixel pro line
         !LDS     R31,       {Breit+1}
      Lo_line:
         !OUT    spdr, R11
      Spi_read20:
         !sbis spsr, spif
         !rjmp spi_read20
         !OUT    spdr, R10
      Spi_read21:
         !sbis spsr, spif
         !rjmp spi_read21

         !SBIW  R30, 1                                      'decr Pixel
         !BRNE Lo_line

         !SBIW   R24, 1                                     'decr hhe
         !brne lo_rows


   Elseif Fill = 2 Then
      Lcd_set_window Xstart , Ystart , Xend , Yend

      Lcd_cs = 0
      Lcd_dc = 1

      !ldd R26, Y+2
      !Ldd R27, Y+3
      !LD R10, X+
      !LD R11, X
      !LDS     R24,       {Hoehe}                           'Anzahl lines
      !LDS     R25,       {Hoehe+1}
      Lo_rows1:
         !LDS     R30,       {Breit}                        'Anzahl Pixel pro line
         !LDS     R31,       {Breit+1}
      Lo_line1:
         !OUT    spdr, R11
      Spi_read22:
         !sbis spsr, spif
         !rjmp spi_read22
         !OUT    spdr, R10
      Spi_read23:
         !sbis spsr, spif
         !rjmp spi_read23

         !SBIW  R30, 1                                      'decr Pixel
         !BRNE Lo_line1

         !SBIW   R24, 1                                     'decr hhe
         !brne lo_rows1

         Decr Yend
         Lcd_line Xstart , Ystart , Xend , Ystart , 2 , Bordercolor
         Lcd_line Xstart , Yend , Xend , Yend , 2 , Bordercolor
         Lcd_line Xstart , Ystart , Xstart , Yend , 2 , Bordercolor
         Decr Xend
         Lcd_line Xend , Ystart , Xend , Yend , 2 , Bordercolor
   Elseif Fill = 3 Then
      Lcd_line Xstart , Ystart , Xend , Ystart , 2 , Bordercolor
      Lcd_line Xstart , Yend , Xend , Yend , 2 , Bordercolor
      Lcd_line Xstart , Ystart , Xstart , Yend , 2 , Bordercolor
      Decr Xend
      Lcd_line Xend , Ystart , Xend , Yend , 2 , Bordercolor

   End If
   Lcd_cs = 1
End Sub

'*******************************************************************************
' Lcd show BGC File  X Start  Y Start
' Important that you first RESTORE the image before calling this sub
'*******************************************************************************
Sub Lcd_show_bgc(byval Xoffset As Word , Byval Yoffset As Word)

   Local Ysize As Byte , Xsize As Byte
   Local Imagesize As Word
   Local L As Word , Pixel As Byte ,
   Local Pixelword As Word , Repeat As Byte
   Local X1size As Word , Y1size As Word , Yadd As Word , Tem As Word


   Read Ysize                                               'Read the first 4 bytes from the BGC, this contains info about the image
   Read Xsize
   Read Imagesize                                           'Byte 3&4 contains the image size

   X1size = Xsize
   Y1size = Ysize

   X1size = Xoffset + X1size
   Decr X1size
   Y1size = Y1size + Yoffset
   Call Lcd_set_window(xoffset , Yoffset , X1size , Y1size)


   Lcd_cs = 0
   Lcd_dc = 1
   Do
      Read Pixel                                            'Read the value for the pixel
      If Pixel = &HAA Then                                  'BGC file is rle coded &HAA represents this, the byte after &HAA is the number of times that the byte before &HAA wil be repeated
         Read Repeat                                        'Byte after &HAA contains the number of times to repeat
         Repeat = Repeat - 1
         For L = 1 To Repeat                                'Loop the repeat
            !OUT    spdr, R10
      Spi_read40:
            !sbis spsr, spif
            !rjmp spi_read40
            !OUT    spdr, R11
      Spi_read41:
            !sbis spsr, spif
            !rjmp spi_read41
            Decr Imagesize                                  'Decrease the bytes still to be processed
         Next L                                             'Next repeat loop
      Else

            Rgb16 = Rgb8to16(pixel)
            !LDS     R11,       {Rgb16}                     'Anzahl Pixel pro line
            !LDS     R10,       {Rgb16+1}
            !OUT    spdr, R10
      Spi_read42:
            !sbis spsr, spif
            !rjmp spi_read42
            !OUT    spdr, R11
      Spi_read43:
            !sbis spsr, spif
            !rjmp spi_read43

       '  Prevpixel = Rgb16                                  'Store the pixel in a temp word, maybe we need it if the next byte is &HAA
         Decr Imagesize
      End If
   Loop Until Imagesize = 0                                 'Do until all bytes are processed
   Lcd_cs = 1

End Sub

'*******************************************************************************
' Draw Text String  x y Start - Font Nr - Forecolor - Backcolor - Bold Nr 1 - 2 - 3 -4  1 is normal
' Beta Test
'*******************************************************************************
Sub Lcd_text(byval Lcd_text As String , Byval Lcd_posx As Word , Byval Lcd_posy As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word , Byval Bold As Byte)

   Local Pzeichen As String * 1
   Local Zeichen_row As Word
   Local Ptemp As Word
   Local Ptemp2 As Word
   Local Px As Word
   Local Py As Word
   Local Char_rows As Byte
   Local Char_row_len As Byte
   Local Char_bytes As Byte
   Local Dummy As Byte
   Local String_pos As Byte
   Local Zeichen_code As Word
   Local Fcolh As Byte , Fcoll As Byte , Bacolh As Byte , Bacoll As Byte
   Local Doph As Word , Zbv As Byte
   Fcolh = High(forecolor)
   Fcoll = Low(forecolor)
   Bacolh = High(backcolor)
   Bacoll = Low(backcolor)

   Select Case Fontset
'(
      Case 2:
         Char_rows = Lookup(0 , Font12x16)
         Char_row_len = Lookup(1 , Font12x16)
         Char_bytes = Lookup(2 , Font12x16)
         Dummy = Lookup(3 , Font12x16)

      Case 1:

     Case 3:
         Char_rows = Lookup(0 , Crn20x24)
         Char_row_len = Lookup(1 , Crn20x24)
         Char_bytes = Lookup(2 , Crn20x24)
         Dummy = Lookup(3 , Crn20x24)
      Case 4:
         Char_rows = Lookup(0 , Digital20x32)
         Char_row_len = Lookup(1 , Digital20x32)
         Char_bytes = Lookup(2 , Digital20x32)
         Dummy = Lookup(3 , Digital20x32)

      Case 1:
         Char_rows = Lookup(0 , Font8x8)
         Char_row_len = Lookup(1 , Font8x8)
         Char_bytes = Lookup(2 , Font8x8)
         Dummy = Lookup(3 , Font8x8)
')
      Case 1:
         Char_rows = Lookup(0 , Font12x16)
         Char_row_len = Lookup(1 , Font12x16)
         Char_bytes = Lookup(2 , Font12x16)
         Dummy = Lookup(3 , Font12x16)

      Case 2:
         Char_rows = Lookup(0 , Crn20x24)
         Char_row_len = Lookup(1 , Crn20x24)
         Char_bytes = Lookup(2 , Crn20x24)
         Dummy = Lookup(3 , Crn20x24)
'(
      Case 4:
         Char_rows = Lookup(0 , Font25x32)
         Char_row_len = Lookup(1 , Font25x32)
         Char_bytes = Lookup(2 , Font25x32)
         Dummy = Lookup(3 , Font25x32)
      Case 5:
         Char_rows = Lookup(0 , Luc_C19x24)
         Char_row_len = Lookup(1 , Luc_C19x24)
         Char_bytes = Lookup(2 , Luc_C19x24)
         Dummy = Lookup(3 , Luc_C19x24)
      Case 6:
         Char_rows = Lookup(0 , Luc_C20x26)
         Char_row_len = Lookup(1 , Luc_C20x26)
         Char_bytes = Lookup(2 , Luc_C20x26)
         Dummy = Lookup(3 , Luc_C20x26)
')
   End Select

   For String_pos = 1 To Len(lcd_text)                      'Fr jedes Zeichen im String
      Pzeichen = Mid(lcd_text , String_pos , 1)             'Ein Zeichen aus String holen
      Zeichen_code = Asc(pzeichen) - 32                     'Font files start with caracter 32
      Zeichen_code = Zeichen_code * Char_bytes

      Doph = Zeichen_code
      Doph = Doph + 4
      For Px = 1 To Char_bytes

         Select Case Fontset
'            Case 1 : Zeichenarray(px) = Lookup(doph , font8x8)
            Case 1 : Zeichenarray(px) = Lookup(doph , Font12x16)
            Case 2 : Zeichenarray(px) = Lookup(doph , Crn20x24)
'            Case 4 : Zeichenarray(px) = Lookup(doph , Font25x32)
'            Case 5 : Zeichenarray(px) = Lookup(doph , Luc_C19x24)
'            Case 6 : Zeichenarray(px) = Lookup(doph , Luc_C20x26)
         End Select
         Incr Doph

      Next Px

      Py = Char_rows * 8
      Py = Py * Bold
      Py = Py + Lcd_posy

      Px = String_pos - 1
      Px = Px * Char_row_len
      Px = Px + Lcd_posx

      Select Case Bold
         Case 1:
            Ptemp = Px + Char_row_len
         Case 2:
            Px = Px * Bold                                  '* 2
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
         Case 3:
            Px = Px * Bold                                  '* 3
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
         Case 4:
            Px = Px * Bold                                  '* 4
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
      End Select

      Decr Ptemp
      Call Lcd_set_window(px , Lcd_posy , Ptemp , Py)
      Lcd_cs = 0
      Lcd_dc = 1

      For Py = 1 To Char_rows
         Ptemp = Py - 1
         Ptemp = Ptemp * Char_row_len

         For Zeichen_row = 0 To 7
            For Doph = 1 To Bold
               For Px = 1 To Char_row_len
                  Ptemp2 = Ptemp + Px
                  If Zeichenarray(ptemp2).zeichen_row = 1 Then
                     For Zbv = 1 To Bold
                        Spiout Fcolh , 1
                        Spiout Fcoll , 1
                     Next Zbv
                  Else
                     For Zbv = 1 To Bold
                        Spiout Bacolh , 1
                        Spiout Bacoll , 1
                     Next Zbv
                  End If
               Next Px
            Next Doph
         Next Zeichen_row
      Next Py
   Next String_pos
   Lcd_cs = 1
End Sub
'*******************************************************************************
' draw Circle
'*******************************************************************************
Sub Lcd_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color As Word)
   Local X0 As Word , Y0 As Word , Error As Integer
   Local Xp As Word , Yp As Word , Xe As Word , Ye As Word

   Error = -radius
   Xp = Radius
   Yp = 0

   While Xp >= Yp
      X0 = X + Xp : Y0 = Y + Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Xp : Y0 = Y + Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X + Xp : Y0 = Y - Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Xp : Y0 = Y - Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)

      X0 = X + Yp : Y0 = Y + Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Yp : Y0 = Y + Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X + Yp : Y0 = Y - Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Yp : Y0 = Y - Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      Error = Error + Yp
      Incr Yp
      Error = Error + Yp

      If Error >= 0 Then
         Decr Xp
         Error = Error - Xp
         Error = Error - Xp
      End If
   Wend
End Sub
'-------------------------------------------------------------------------------
'LCD Fill Circle
'-------------------------------------------------------------------------------
Sub Lcd_fill_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color1 As Word)

   Local Xy_radius As Integer
   Local Zahly As Integer
   Local Zahlx As Integer

   Local Y1 As Integer
   Local X1 As Integer

   Local Y11 As Integer
   Local X11 As Integer
   Local Xy As Integer

   Local X2 As Word , Y2 As Word


   Xy_radius = Radius * Radius

   Y1 = -radius
   X1 = -radius
   Lcd_cs = 0
   For Zahly = Y1 To Radius
      Y11 = Zahly * Zahly
      For Zahlx = X1 To Radius
         X11 = Zahlx * Zahlx
         Xy = X11 + Y11
         If Xy <= Xy_radius Then

            X2 = X + Zahlx
            Y2 = Y + Zahly
            Call Lcd_set_pixel(x2 , Y2 , Color1)
         End If
      Next
   Next

End Sub

'*******************************************************************************
'Draw Line
'*******************************************************************************
Sub Lcd_line(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Pen_width As Byte , Byval Color As Word)
   Local Y As Word , X As Word , X_diff As Single , Y_diff As Single , Pos As Word
   Local X_factor As Single , X_pos As Word , Y_pos As Word , Base As Word , Pen_count As Byte
   Local Y_count As Word , X_count As Word

   Y_diff = Y2 - Y1
   X_diff = X2 - X1
   Pos = 0

   X_factor = Abs(y_diff)
   Y = X_factor
   X_factor = Abs(x_diff)
   X = X_factor

   Lcd_cs = 0
   If Y > X Then
      X_factor = X_diff / Y_diff
      If Y1 > Y2 Then
         Swap Y1 , Y2
         Base = X2
      Else
         Base = X1
      End If
      For Y = Y1 To Y2
         X_diff = Pos * X_factor
         X_pos = X_diff
         X_pos = X_pos + Base
         For Pen_count = 1 To Pen_width
            Call Lcd_set_pixel(x_pos , Y , Color)
            Incr X_pos
         Next Pen_count
         Incr Pos
      Next Y
   Else
      X_factor = Y_diff / X_diff
      If X1 > X2 Then
         Swap X1 , X2
         Base = Y2
      Else
         Base = Y1
      End If
      For X = X1 To X2
         Y_diff = Pos * X_factor
         Y_pos = Y_diff
         Y_pos = Y_pos + Base
         For Pen_count = 1 To Pen_width
            Call Lcd_set_pixel(x , Y_pos , Color)
            Incr Y_pos
         Next Pen_count
         Incr Pos
      Next X
   End If

End Sub
'*******************************************************************************
'Set Pixel
'*******************************************************************************
Sub Lcd_set_pixel(byval X As Word , Byval Y As Word , Byval Color As Word)


   Lcd_cs = 0
   Lcd_dc = 0
   !LDI  R23, $2a
   !OUT    spdr, R23
   Spi_10:
      !sbis spsr, spif
      !rjmp spi_10

      Lcd_cs = 1
      Lcd_cs = 0

      Lcd_dc = 1

      !ldd R26, Y+4
      !Ldd R27, Y+5
      !LD R10, X+
      !LD R11, X
      !OUT    spdr, R11
   Spi_read0:
      !sbis spsr, spif
      !rjmp spi_read0
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R10
   Spi_read2:
      !sbis spsr, spif
      !rjmp spi_read2
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R11
   Spi_read3:
      !sbis spsr, spif
      !rjmp spi_read3
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R10
   Spi_read4:
      !sbis spsr, spif
      !rjmp spi_read4
      Lcd_cs = 1
      Lcd_cs = 0
      Lcd_dc = 0
      !LDI  R23, $2b
      !OUT    spdr, R23
   Spi_11:
      !sbis spsr, spif
      !rjmp spi_11
      Lcd_cs = 1
      Lcd_cs = 0

      Lcd_dc = 1

      !ldd R26, Y+2
      !Ldd R27, Y+3
      !LD R10, X+
      !LD R11, X
      !OUT    spdr, R11
   Spi_ready7:
      !sbis spsr, spif
      !rjmp spi_ready7
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R10
   Spi_ready8:
      !sbis spsr, spif
      !rjmp spi_ready8
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R11
   Spi_ready9:
      !sbis spsr, spif
      !rjmp spi_ready9
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R10
   Spi_read8:
      !sbis spsr, spif
      !rjmp spi_read8
      Lcd_cs = 1
      Lcd_cs = 0
      Lcd_dc = 0
      !LDI  R23, $2c
      !OUT    spdr, R23
   Spi_12:
      !sbis spsr, spif
      !rjmp spi_12
      Lcd_cs = 1
      Lcd_cs = 0

      Lcd_dc = 1
      !ldd R26, Y+0
      !Ldd R27, Y+1
      !LD R10, X+
      !LD R11, X
      !OUT    spdr, R11
   Spi_13:
      !sbis spsr, spif
      !rjmp spi_13
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R10
   Spi_14:
      !sbis spsr, spif
      !rjmp spi_14
      Lcd_cs = 1
End Sub

'*******************************************************************************
'  Clear Display
'*******************************************************************************
Sub Lcd_clear(byval Color As Word)

   Lcd_set_window 0 , 0 , X_size , Y_size

   Lcd_cs = 0
   Lcd_dc = 1

   !LD     XL,     Y+0
   !LD     XH,     Y+1
   !LD     R31,    X+
   !LD     R30,    X




      !ldi  R16, $06                                        '153600
   Wgloop0:
      !ldi  R17, $A0
   Wgloop1:
      !ldi  R18, $A0
   Wgloop2:
      !OUT    spdr, R30
   Spi_ready1:
      !sbis spsr, spif
      !rjmp spi_ready1
      !OUT    spdr, R31
   Spi_ready:
      !sbis spsr, spif
      !rjmp spi_ready

      !dec  R18
      !brne WGLOOP2

      !dec  R17
      !brne WGLOOP1

      !dec  R16
      !brne WGLOOP0




'(


      !ldi  R16, $c8                                        '76800   200
   Wgloop0:
      !ldi  R17, $C0                                        '192
   Wloop1:

      !OUT    spdr, R30
   Spi_ready1:
      !sbis spsr, spif
      !rjmp spi_ready1
      !OUT    spdr, R31
   Spi_ready:
      !sbis spsr, spif
      !rjmp spi_ready

      !OUT    spdr, R30
   Spi_ready2:
      !sbis spsr, spif
      !rjmp spi_ready2
      !OUT    spdr, R31
   Spi_ready3:
      !sbis spsr, spif
      !rjmp spi_ready3

      !subi R17, 1
      !brne wloop1

      !subi R16, 1
      !brne wgloop0

')
      Lcd_cs = 1

End Sub

'*******************************************************************************
' Set Window Area to write Data
'*******************************************************************************
Sub Lcd_set_window(byval Xpos As Word , Byval Ypos As Word , Byval Xsize As Word , Byval Ysize As Word)
'(
    Call Lcd_write_command(&H2a)
    Call Lcd_write_data(high(xpos))
    Call Lcd_write_data(low(xpos))
    Call Lcd_write_data(high(xsize))
    Call Lcd_write_data(low(xsize))

     Call Lcd_write_command(&H2b)
    Call Lcd_write_data(high(ypos))
    Call Lcd_write_data(low(ypos))
    Call Lcd_write_data(high(ysize))
    Call Lcd_write_data(low(ysize))
    Call Lcd_write_command(&H2c)
')

   Lcd_cs = 0
   Lcd_dc = 0
   !LDI  R23, $2a
   !OUT    spdr, R23
   Spi_30:
      !sbis spsr, spif
      !rjmp spi_30
      Lcd_cs = 1
      Lcd_cs = 0

      Lcd_dc = 1

      !ldd R26, Y+6                                         ' xpos
      !Ldd R27, Y+7
      !LD R18, X+
      !LD R17, X

      !OUT    spdr, R17
   Spi_read31:
      !sbis spsr, spif
      !rjmp spi_read31
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R18
   Spi_read32:
      !sbis spsr, spif
      !rjmp spi_read32
      Lcd_cs = 1
      Lcd_cs = 0

      !ldd R26, Y+2                                         ' xsize
      !Ldd R27, Y+3
      !LD R18, X+
      !LD R17, X
      !OUT    spdr, R17
   Spi_read33:
      !sbis spsr, spif
      !rjmp spi_read33
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R18
   Spi_read34:
      !sbis spsr, spif
      !rjmp spi_read34
      Lcd_cs = 1
      Lcd_cs = 0

      Lcd_dc = 0
      !LDI  R23, $2b
      !OUT    spdr, R23
   Spi_35:
      !sbis spsr, spif
      !rjmp spi_35
      Lcd_cs = 1
      Lcd_cs = 0

      Lcd_dc = 1

      !ldd R26, Y+4                                         ' ypos
      !Ldd R27, Y+5
      !LD R18, X+
      !LD R17, X
      !OUT    spdr, R17
   Spi_read36:
      !sbis spsr, spif
      !rjmp spi_read36
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R18
   Spi_read37:
      !sbis spsr, spif
      !rjmp spi_read37
      Lcd_cs = 1
      Lcd_cs = 0

      !ldd R26, Y+0                                         ' ysize
      !Ldd R27, Y+1
      !LD R18, X+
      !LD R17, X
      !OUT    spdr, R17
   Spi_read38:
      !sbis spsr, spif
      !rjmp spi_read38
      Lcd_cs = 1
      Lcd_cs = 0
      !OUT    spdr, R18
   Spi_read39:
      !sbis spsr, spif
      !rjmp spi_read39
      Lcd_cs = 1
      Lcd_cs = 0

      Lcd_dc = 0
      !LDI  R23, $2c
      !OUT    spdr, R23
   Spi_40:
      !sbis spsr, spif
      !rjmp spi_40
      Lcd_cs = 1
      Lcd_cs = 0

      Lcd_cs = 1

End Sub


'*******************************************************************************
' send Color Data
'*******************************************************************************
Sub Lcd_write_color(byval Color As Word)

   Rgb16 = Color

   Lcd_cs = 0
   Lcd_dc = 1
   Spiout Rgb16_high , 1
   Spiout Rgb16_low , 1
   Lcd_cs = 1
End Sub
'*******************************************************************************
' send Command
'*******************************************************************************
Sub Lcd_write_command(byval Command As Byte)
   Lcd_cs = 0
   Lcd_dc = 0
   Spiout Command , 1
   Lcd_cs = 1
End Sub
'*******************************************************************************
'  send Data
'*******************************************************************************
Sub Lcd_write_data(byval Da_ta As Byte)
   Lcd_cs = 0
   Lcd_dc = 1
   Spiout Da_ta , 1
   Lcd_cs = 1
End Sub
'*******************************************************************************
' Init the display
'*******************************************************************************
Sub Lcd_init()
   Lcd_reset = 0
   Waitms 150
   Lcd_reset = 1
   Waitms 150

    Call Lcd_write_command(&Hf9)
    Call Lcd_write_data(&H00)
    Call Lcd_write_data(&H08)

    Call Lcd_write_command(&Hc0)
    Call Lcd_write_data(&H19)                               'VREG1OUT POSITIVE
    Call Lcd_write_data(&H1a)                               'VREG2OUT NEGATIVE

    Call Lcd_write_command(&Hc1)
    Call Lcd_write_data(&H45)                               'VGH,VGL    VGH>=14V.
    Call Lcd_write_data(&H00)

    Call Lcd_write_command(&Hc2)                            'Normal mode, increase can change the display quality, while increasing power consumption
    Call Lcd_write_data(&H33)

    Call Lcd_write_command(&Hc5)
    Call Lcd_write_data(&H00)
    Call Lcd_write_data(&H28)                               'VCM_REG[7:0]. <=0X80.

    Call Lcd_write_command(&Hb1)                            'Sets the frame frequency of full color normal mode
    Call Lcd_write_data(&Ha0)                               '0XB0 =70HZ, <=0XB0.0xA0=62HZ
    Call Lcd_write_data(&H11)

    Call Lcd_write_command(&Hb4)
    Call Lcd_write_data(&H02)                               ' 2 DOT FRAME MODE,F<=70HZ.

    Call Lcd_write_command(&Hb6)
    Call Lcd_write_data(&H00)
   ' Call Lcd_write_data(&H42)
    Call Lcd_write_data(&B0000_0010)

    Call Lcd_write_data(&H3b)

    Call Lcd_write_command(&Hb7)
    Call Lcd_write_data(&H07)

    Call Lcd_write_command(&He0)
    Call Lcd_write_data(&H1f)
    Call Lcd_write_data(&H25)
    Call Lcd_write_data(&H22)
    Call Lcd_write_data(&H0b)
    Call Lcd_write_data(&H06)
    Call Lcd_write_data(&H0a)
    Call Lcd_write_data(&H4e)
    Call Lcd_write_data(&Hc6)
    Call Lcd_write_data(&H39)
    Call Lcd_write_data(&H00)
    Call Lcd_write_data(&H00)
    Call Lcd_write_data(&H00)
    Call Lcd_write_data(&H00)
    Call Lcd_write_data(&H00)
    Call Lcd_write_data(&H00)

    Call Lcd_write_command(&He1)
    Call Lcd_write_data(&H1f)
    Call Lcd_write_data(&H3f)
    Call Lcd_write_data(&H3f)
    Call Lcd_write_data(&H0f)
    Call Lcd_write_data(&H1f)
    Call Lcd_write_data(&H0f)
    Call Lcd_write_data(&H46)
    Call Lcd_write_data(&H49)
    Call Lcd_write_data(&H31)
    Call Lcd_write_data(&H05)
    Call Lcd_write_data(&H09)
    Call Lcd_write_data(&H03)
    Call Lcd_write_data(&H1c)
    Call Lcd_write_data(&H1a)
    Call Lcd_write_data(&H00)

    Call Lcd_write_command(&Hf1)
    Call Lcd_write_data(&H36)
    Call Lcd_write_data(&H04)
    Call Lcd_write_data(&H00)
    Call Lcd_write_data(&H3c)
    Call Lcd_write_data(&H0f)
    Call Lcd_write_data(&H0f)
    Call Lcd_write_data(&Ha4)
    Call Lcd_write_data(&H02)

    Call Lcd_write_command(&Hf2)
    Call Lcd_write_data(&H18)
    Call Lcd_write_data(&Ha3)
    Call Lcd_write_data(&H12)
    Call Lcd_write_data(&H02)
    Call Lcd_write_data(&H32)
    Call Lcd_write_data(&H12)
    Call Lcd_write_data(&Hff)
    Call Lcd_write_data(&H32)
    Call Lcd_write_data(&H00)

    Call Lcd_write_command(&Hf4)
    Call Lcd_write_data(&H40)
    Call Lcd_write_data(&H00)
    Call Lcd_write_data(&H08)
    Call Lcd_write_data(&H91)
    Call Lcd_write_data(&H04)

    Call Lcd_write_command(&Hf8)
    Call Lcd_write_data(&H21)
    Call Lcd_write_data(&H04)

    Call Lcd_write_command(&H3a)                            'COLMOD: Pixel Format Set
    Call Lcd_write_data(&H55)

   ' Call Lcd_write_command(&H36)                            'Memory Access Control
   ' Call Lcd_write_data(&B01001000)                                             '0100-1000

   #if Lcd_mode = 1
      Call Lcd_write_command(&H36)                          'Memory Access Control
      Call Lcd_write_data(&B0100_1000)                      '0100-1000
   #elseif Lcd_mode = 2
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B1000_1000)
   #elseif Lcd_mode = 3
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B1110_1000)

   #elseif Lcd_mode = 4
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B0010_1000)
   #endif

    Waitms 150
    Call Lcd_write_command(&H11)                            'Exit Sleep
    Waitms 150
    Call Lcd_write_command(&H29)                            'normal display on
    Waitms 150

  '(
   Call Lcd_write_command(&Hcb)                             'Power control A
   Call Lcd_write_data(&H39)
   Call Lcd_write_data(&H2c)
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H34)
   Call Lcd_write_data(&H02)

   Call Lcd_write_command(&Hcf)                             'Power control B
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&Hc1)                                '8b
   Call Lcd_write_data(&H30)

   Call Lcd_write_command(&He8)                             'Driver timing control A (
   Call Lcd_write_data(&H85)
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H78)


   Call Lcd_write_command(&Hea)                             'Driver timing control B
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H00)


   Call Lcd_write_command(&Hed)                             'Power on sequence control
   Call Lcd_write_data(&H64)
   Call Lcd_write_data(&H03)
   Call Lcd_write_data(&H12)
   Call Lcd_write_data(&H81)

   Call Lcd_write_command(&Hf7)                             'Pump ratio control
   Call Lcd_write_data(&H20)

   Call Lcd_write_command(&Hc0)                             'Power control
   Call Lcd_write_data(&H23)

   Call Lcd_write_command(&Hc1)                             'Power control
   Call Lcd_write_data(&H10)

   Call Lcd_write_command(&Hc5)                             'VCM control
   Call Lcd_write_data(&H3e)
   Call Lcd_write_data(&H28)

   Call Lcd_write_command(&Hc7)                             'VCOM Control 2
   Call Lcd_write_data(&H86)

   #if Lcd_mode = 1
      Call Lcd_write_command(&H36)                          'Memory Access Control
      Call Lcd_write_data(&B0100_1000)                      '0100-1000
   #elseif Lcd_mode = 2
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B1000_1000)
   #elseif Lcd_mode = 3
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B1110_1000)

   #elseif Lcd_mode = 4
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B0010_1000)
   #endif

   Call Lcd_write_command(&H3a)                             'COLMOD: Pixel Format Set
   Call Lcd_write_data(&H55)

   Call Lcd_write_command(&Hb1)                             'Frame Rate Control (In Normal Mode/Full Colors)
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H18)

   Call Lcd_write_command(&Hb6)                             'Display Function Control
   Call Lcd_write_data(&H08)
   Call Lcd_write_data(&H82)
   Call Lcd_write_data(&H27)

   Call Lcd_write_command(&Hf2)                             '3Gamma Function Disable
   Call Lcd_write_data(&H00)

   Call Lcd_write_command(&H26)                             'Gamma curve selected
   Call Lcd_write_data(&H01)


   Call Lcd_write_command(&He0)                             'Set Gamma
   Call Lcd_write_data(&H0f)
   Call Lcd_write_data(&H31)
   Call Lcd_write_data(&H2b)
   Call Lcd_write_data(&H0c)
   Call Lcd_write_data(&H0e)
   Call Lcd_write_data(&H08)
   Call Lcd_write_data(&H4e)
   Call Lcd_write_data(&Hf1)
   Call Lcd_write_data(&H37)
   Call Lcd_write_data(&H07)
   Call Lcd_write_data(&H10)
   Call Lcd_write_data(&H03)
   Call Lcd_write_data(&H0e)
   Call Lcd_write_data(&H09)
   Call Lcd_write_data(&H00)

   Call Lcd_write_command(&He1)                             'Set Gamma
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H0e)
   Call Lcd_write_data(&H14)
   Call Lcd_write_data(&H03)
   Call Lcd_write_data(&H11)
   Call Lcd_write_data(&H07)
   Call Lcd_write_data(&H31)
   Call Lcd_write_data(&Hc1)
   Call Lcd_write_data(&H48)
   Call Lcd_write_data(&H08)
   Call Lcd_write_data(&H0f)
   Call Lcd_write_data(&H0c)
   Call Lcd_write_data(&H31)
   Call Lcd_write_data(&H36)
   Call Lcd_write_data(&H0f)


   Call Lcd_write_command(&H11)                             'Exit Sleep
   Waitms 150
   Call Lcd_write_command(&H29)                             'normal display on
   Waitms 150
')
End Sub